using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using DevExpress.Xpo;
using DevExpress.Data.Filtering;
using DevExpress.Xpo.DB;
using System.IO;
using System.Text;
using System.Collections;

namespace DXGridXPOBinding {
  public class LogWriter : TextWriter {
    public LogWriter( ) {
    }

    Encoding enc = new UnicodeEncoding( );
    public override Encoding Encoding {
      get { return enc; }
    }

    List<string> buffer = new List<string>( );

    public override void Write(string value) {
      lock (((IList) buffer).SyncRoot) {
        buffer.Add(value);
        OnTextAdded( );
      }
    }
    public IList<string> RetrieveText( ) {
      IList<string> result;
      lock (((IList) buffer).SyncRoot) {
        result = new List<string>(buffer);
        buffer.Clear( );
      }
      return result;
    }

    public event EventHandler TextAdded;
    protected virtual void OnTextAdded( ) {
      if (TextAdded != null)
        TextAdded(this, EventArgs.Empty);
    }

    public override void Write(char ch) {
      Write(ch.ToString( ));
    }

  }
}
