using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using DevExpress.Xpo;

namespace DXGridXPOBinding {
  public class Order : XPObject {
    public Order(Session session)
      : base(session) { }

    private DateTime date;
    public DateTime Date {
      get {
        return date;
      }
      set {
        SetPropertyValue("Date", ref date, value);
      }
    }

    private Customer customer;
    [Association("Customer-Orders")]
    public Customer Customer {
      get {
        return customer;
      }
      set {
        SetPropertyValue("Customer", ref customer, value);
      }
    }

    [Association("Order-OrderLines")]
    public XPCollection<OrderLine> OrderLines {
      get {
        return GetCollection<OrderLine>("OrderLines");
      }
    }
  }
}
